# SmallVector< T, S > Class Template Reference

Simple vector template class. More...

`#include <smallvec_type.hpp>`

Inheritance diagram for SmallVector< T, S >:

## Public Member Functions

FORCEINLINE void | Clear ()
| Remove all items from the list.
FORCEINLINE void | Reset ()
| Remove all items from the list and free allocated memory.
FORCEINLINE void | Compact ()
| Compact the list down to the smallest block size boundary.
FORCEINLINE T * | Append (uint to_add=1)
| Append an item and return it.
FORCEINLINE const T * | Find (const T &item) const
| Search for the first occurence of an item.
FORCEINLINE T * | Find (const T &item)
| Search for the first occurence of an item.
FORCEINLINE int | FindIndex (const T &item)
| Search for the first occurence of an item.
FORCEINLINE bool | Contains (const T &item) const
| Tests whether a item is present in the vector.
FORCEINLINE void | Erase (T *item)
| Removes given item from this vector.
FORCEINLINE bool | Include (const T &item)
| Tests whether a item is present in the vector, and appends it to the end if not.
FORCEINLINE uint | Length () const
| Get the number of items in the list.
FORCEINLINE const T * | Begin () const
| Get the pointer to the first item (const).
FORCEINLINE T * | Begin ()
| Get the pointer to the first item.
FORCEINLINE const T * | End () const
| Get the pointer behind the last valid item (const).
FORCEINLINE T * | End ()
| Get the pointer behind the last valid item.
FORCEINLINE const T * | Get (uint index) const
| Get the pointer to item "number" (const).
FORCEINLINE T * | Get (uint index)
| Get the pointer to item "number".
FORCEINLINE const T & | operator[] (uint index) const
| Get item "number" (const).
FORCEINLINE T & | operator[] (uint index)
| Get item "number".

## Protected Attributes

T * | data
| The pointer to the first item.
uint | items
| The number of items stored.
uint | capacity
| The avalible space for storing items.

## Detailed Description

### template<typename T, uint S>
class SmallVector< T, S >

Simple vector template class.

Note:
  There are no asserts in the class so you have to care about that you grab an item which is inside the list.

Parameters:

  | T | The type of the items stored
  | S | The steps of allocation

Definition at line 29 of file smallvec_type.hpp.

## Member Function Documentation

template<typename T, uint S>

FORCEINLINE T* SmallVector< T, S >::Append | ( | uint | to_add = `1` | ) | `[inline]`

Append an item and return it.

Parameters:

  | to_add | the number of items to append

Returns:
  pointer to newly allocated item

Definition at line 82 of file smallvec_type.hpp.

Referenced by AddChildSpriteScreen(), FiosFileScanner::AddFile(), AddNearbyStation(), AddSortableSpriteToDraw(), AddTileSpriteToDraw(), BuildDepotVehicleList(), NewGRFAddWindow::BuildGrfList(), IndustryDirectoryWindow::BuildSortIndustriesList(), CompanyStationsWindow::BuildStationsList(), CmdBuildRailStation(), CmdConvertRail(), DrawString(), FindIndustryToDeliver(), FindStationsNearby(), FiosGetFileList(), ReplaceVehicleWindow::GenerateReplaceVehList(), GenerateVehicleSortList(), GetCargoSummaryOfArticulatedVehicle(), GetNewEngine(), SmallVector< RefitOption, 32 >::Include(), ini_load_setting_list(), MakeTrainBackup(), and ShowBuildBridgeWindow().

template<typename T, uint S>

FORCEINLINE const T* SmallVector< T, S >::Find | ( | const T & | item | ) | const`[inline]`

Search for the first occurence of an item.

The '!=' operator of T is used for comparison.

Parameters:

  | item | Item to search for

Returns:
  The position of the item, or End() when not present

Definition at line 101 of file smallvec_type.hpp.

Referenced by SmallVector< RefitOption, 32 >::Contains(), and GetCargoSummaryOfArticulatedVehicle().

template<typename T, uint S>

FORCEINLINE T* SmallVector< T, S >::Find | ( | const T & | item | ) | `[inline]`

Search for the first occurence of an item.

The '!=' operator of T is used for comparison.

Parameters:

  | item | Item to search for

Returns:
  The position of the item, or End() when not present

Definition at line 115 of file smallvec_type.hpp.

template<typename T, uint S>

FORCEINLINE int SmallVector< T, S >::FindIndex | ( | const T & | item | ) | `[inline]`

Search for the first occurence of an item.

The '!=' operator of T is used for comparison.

Parameters:

  | item | Item to search for

Returns:
  The position of the item, or -1 when not present

Definition at line 129 of file smallvec_type.hpp.

Referenced by FinalisePriceBaseMultipliers(), and NewGRFAddWindow::UpdateListPosition().

template<typename T, uint S>

FORCEINLINE bool SmallVector< T, S >::Contains | ( | const T & | item | ) | const`[inline]`

Tests whether a item is present in the vector.

The '!=' operator of T is used for comparison.

Parameters:

  | item | Item to test for

Returns:
  true iff the item is present

Definition at line 147 of file smallvec_type.hpp.

Referenced by AddNearbyStation(), FindIndustryToDeliver(), SmallVector< RefitOption, 32 >::Include(), and WhoCanServiceIndustry().

template<typename T, uint S>

FORCEINLINE void SmallVector< T, S >::Erase | ( | T * | item | ) | `[inline]`

Removes given item from this vector.

Parameters:

  | item | item to remove

Note:
  it has to be pointer to item in this map. It is overwritten by the last item.

Definition at line 157 of file smallvec_type.hpp.

Referenced by AddNearbyStation().

template<typename T, uint S>

FORCEINLINE bool SmallVector< T, S >::Include | ( | const T & | item | ) | `[inline]`

Tests whether a item is present in the vector, and appends it to the end if not.

The '!=' operator of T is used for comparison.

Parameters:

  | item | Item to test for

Returns:
  true iff the item is was already present

Definition at line 169 of file smallvec_type.hpp.

Referenced by BuildRefitList(), CheckSubsidised(), DeliverGoodsToIndustry(), FindStationsAroundTiles(), and RemoveFromRailBaseStation().

template<typename T, uint S>

FORCEINLINE const T* SmallVector< T, S >::Begin | ( |  | ) | const`[inline]`

Get the pointer to the first item (const).

Returns:
  the pointer to the first item

Definition at line 189 of file smallvec_type.hpp.

Referenced by FiosFileScanner::AddFile(), CheckSubsidised(), CmdRemoveFromRailStation(), DrawString(), EngList_Sort(), SmallVector< RefitOption, 32 >::Erase(), FinaliseHouseArray(), FinaliseIndustriesArray(), FinalisePriceBaseMultipliers(), SmallVector< RefitOption, 32 >::Find(), SmallVector< RefitOption, 32 >::FindIndex(), FiosGetFileList(), BaseSet< MusicSet, NUM_SONGS_AVAILABLE, GM_DIR >::GetDescription(), ini_save_setting_list(), LoadUnloadStation(), MoveWaypointsToBaseStations(), RemoveFromRailBaseStation(), RestoreTrainBackup(), UpdateWaypointOrder(), ViewportDrawBoundingBoxes(), ViewportSortParentSprites(), and BaseSet< MusicSet, NUM_SONGS_AVAILABLE, GM_DIR >::~BaseSet().

template<typename T, uint S>

FORCEINLINE T* SmallVector< T, S >::Begin | ( |  | ) | `[inline]`

Get the pointer to the first item.

Returns:
  the pointer to the first item

Definition at line 199 of file smallvec_type.hpp.

template<typename T, uint S>

FORCEINLINE const T* SmallVector< T, S >::End | ( |  | ) | const`[inline]`

Get the pointer behind the last valid item (const).

Returns:
  the pointer behind the last valid item

Definition at line 209 of file smallvec_type.hpp.

Referenced by AddCombinedSprite(), FiosFileScanner::AddFile(), CheckSubsidised(), CmdRemoveFromRailStation(), SmallVector< RefitOption, 32 >::Contains(), DrawString(), SmallVector< RefitOption, 32 >::Erase(), FinaliseHouseArray(), FinaliseIndustriesArray(), FinalisePriceBaseMultipliers(), SmallVector< RefitOption, 32 >::Find(), SmallVector< RefitOption, 32 >::FindIndex(), GetCargoSummaryOfArticulatedVehicle(), BaseSet< MusicSet, NUM_SONGS_AVAILABLE, GM_DIR >::GetDescription(), ini_save_setting_list(), LoadUnloadStation(), MoveWaypointsToBaseStations(), RemoveFromRailBaseStation(), RestoreTrainBackup(), UpdateWaypointOrder(), ViewportDrawBoundingBoxes(), ViewportSortParentSprites(), and BaseSet< MusicSet, NUM_SONGS_AVAILABLE, GM_DIR >::~BaseSet().

template<typename T, uint S>

FORCEINLINE T* SmallVector< T, S >::End | ( |  | ) | `[inline]`

Get the pointer behind the last valid item.

Returns:
  the pointer behind the last valid item

Definition at line 219 of file smallvec_type.hpp.

template<typename T, uint S>

FORCEINLINE const T* SmallVector< T, S >::Get | ( | uint | index | ) | const`[inline]`

Get the pointer to item "number" (const).

Parameters:

  | index | the position of the item

Returns:
  the pointer to the item

Definition at line 230 of file smallvec_type.hpp.

Referenced by AddNearbyStation(), EngList_SortPartial(), FiosGetFileList(), and GetNewEngine().

template<typename T, uint S>

FORCEINLINE T* SmallVector< T, S >::Get | ( | uint | index | ) | `[inline]`

Get the pointer to item "number".

Parameters:

  | index | the position of the item

Returns:
  the pointer to the item

Definition at line 243 of file smallvec_type.hpp.

template<typename T, uint S>

FORCEINLINE const T& SmallVector< T, S >::operator[] | ( | uint | index | ) | const`[inline]`

Get item "number" (const).

Parameters:

  | index | the positon of the item

Returns:
  the item

Definition at line 256 of file smallvec_type.hpp.

template<typename T, uint S>

FORCEINLINE T& SmallVector< T, S >::operator[] | ( | uint | index | ) | `[inline]`

Get item "number".

Parameters:

  | index | the positon of the item

Returns:
  the item

Definition at line 268 of file smallvec_type.hpp.

The documentation for this class was generated from the following file:

- src/core/smallvec_type.hpp